package mimic;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Scanner;

/**
 * 
 * This class builds a dictionary of word tuples from a given text file by using the Markov chain principle, 
 * where each two consecutive words in the text know what word can follow them.
 * Then printing a mimic text based on this dictionary.
 */
public class Mimic {

	/**
	 * 
	 * @param filename
	 * @return the dictionary of word tuples based on the given text file. First word tuple is ["",""] - empty Strings.
	 */
	public static WordTuple[] buildDict(String filename){
		/* YOUR CODE GOES HERE */
	}
	
	/**
	 * Prints a mimic text starting with 'startWord1 startWord2' and continuing based on the dictionary.
	 * If the starting phrase (the tuple [startWord1,startWord2]) is not found in the dictionary only an error message will be printed ("ERROR: the starting phrase was not found in the given file").
	 * If (dict==null) the method will only print an error message.
	 * @param dict
	 * @param startWord1
	 * @param startWord2
	 * @param numOfWordsToPrint
	 */
	public static void printMimic(WordTuple[] dict, String startWord1, String startWord2, int numOfWordsToPrint){
		/* YOUR CODE GOES HERE */
	}
	
	/**
	 * @pre (filename!=null)
	 * @param filename
	 * @return an array of String with all the words from the given text file. If file can't be found the program will exit with an error message.
	 */
	private static String[] readFromFile(String filename){
		ArrayList<String> words = new ArrayList<String>();
		
		Scanner text = null;
		try {
			text = new Scanner(new File(filename));
		} catch (FileNotFoundException e) {
			System.out.println("ERROR: Cannot find file "+filename);
			System.exit(-1);
		}
		
		while(text.hasNext())
			words.add(text.next());
		
		String[] retval = new String[words.size()];
		return words.toArray(retval);
	}
	
	/**
	 * Main method:
	 * 	a. Reads and validates input from the user. if the user didn't input all the needed arguments a message will be printed 
	 * 												- "Usage Instructions: Mimic <filename> <startWord1> <startWord2> <wordCount>"
	 * 	b. Builds a dictionary from a text file
	 * 	c. Prints a mimic text based on the dictionary and the starting words.
	 * @param args
	 */
	public static void main(String[] args){
		/* YOUR CODE GOES HERE */
	}
	
}
