package mimic;

import java.util.Random;

/**
 * 
 * This class represents a Tuple of two word [prevWord , currWord]. Each tuple also includes an array with references to other word tuples that follow this tuple.
 *
 */
public class WordTuple {

	private String prevWord;
	private String currWord;
	private WordTuple[] followingWordTuples;
	private int numOfTuples;
	
	/**
	 * Constructor for the class
	 * 
	 * @pre (prevWord!=null)&&(currWord!=null)
	 * @param prevWord
	 * @param currWord
	 */
	public WordTuple(String prevWord, String currWord){
		followingWordTuples = new WordTuple[20];
		numOfTuples = 0;
		this.prevWord = prevWord;
		this.currWord = currWord;
	}
	
	/**
	 * 
	 * @return the previous word from this tuple [prevWord,currWord]
	 */
	public String getPrevWord(){
		/* YOUR CODE GOES HERE */
	}
	
	/**
	 * 
	 * @return the current word from this tuple [prevWord,currWord]
	 */
	public String getCurrWord(){
		/* YOUR CODE GOES HERE */
	}
	
	/**
	 * 
	 * @return one of the following word tuples which is randomly chosen between all following tuples. If there are no following tuples returns 'null'.
	 */
	public WordTuple getNextTuple(){
		/* YOUR CODE GOES HERE */
	}
	
	/**
	 * 
	 * @return the number of following tuples.
	 */
	public int getNumOfFollowingTuples(){
		/* YOUR CODE GOES HERE */
	}
	
	/**
	 * Sets the previous word of the tuple [prevWord,currWord] to the given string.
	 * @pre (prevWord!=null)
	 * @param prevWord
	 */
	public void setPrevWord(String prevWord){
		/* YOUR CODE GOES HERE */
	}
	
	/**
	 * Sets the current word of the tuple [prevWord,currWord] to the given string.
	 * @pre (currWord!=null)
	 * @param currWord
	 */
	public void setCurrWord(String currWord){
		/* YOUR CODE GOES HERE */
	}
	
	/**
	 * 
	 * @param newWord
	 * @return 'true' if one of the following word tuples holds: (followingTuple.getPrevWord().equals(this.getCurrWord()) 
	 * 														&&  followingTuple.getCurrWord().equals(newWord)), otherwise returns false.
	 */
	public boolean followingWordsContatin(String newWord){
		/* YOUR CODE GOES HERE */
	}
	
	/**
	 * Adds the given tuple to the following tuples array. If the array is full or if the tuple already exist - nothing will be added.
	 * @pre (newWordTuple!=null)
	 * @param newWordTuple
	 */
	public void addFollowingWordTuple(WordTuple newWordTuple){
		/* YOUR CODE GOES HERE */
	}
	
	/**
	 * @return the current word of the tuple [prevWord,currWord].
	 */
	public String toString(){
		return currWord;
	}
}
